<!-- You can use any js library (: -->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Prueba Aimo back</title>
    <link 
        rel="stylesheet" 
        href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" 
        integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" 
        crossorigin="anonymous"
    >
</head>
<body>
    <div id="mostrar-login">
        <div class="d-flex align-items-center px-0">
            <div class="row w-100 mx-0">
                <div class="col-lg-4 mx-auto">
                    <div class="text-left py-5 px-4 px-sm-5">
                        <h4>Hola Aimo! Bienvenidos</h4>
                        <h6 class="font-weight-light">Este es el login de prueba</h6>
                        <form id="formLogin" class="pt-3" method="POST">
                            <div class="form-group">
                                <input type="text" id="username" name="username" class="form-control form-control-lg" placeholder="Nombre de usuario">
                            </div>
                            <div class="form-group">
                                <input type="password" id="password" name="password" class="form-control form-control-lg" placeholder="Contraseña">
                            </div>
                            <div class="mt-3">
                                <button type="button" id="login" class="btn btn-block btn-primary btn-lg font-weight-medium">
                                    Inicia sesión
                                </button>
                            </div>
                            <div id="error-login" style="display:none">
                                <div class="text-danger">Error en el login</div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>  
    </div>
    

    <div id="mostrar-api" style="display:none">
        <div class="container">
            <div class="row pt-4 text-right">
                <button type="button" id="cerrar-sesion" class="btn btn-block btn-danger btn-lg mr-3">
                    Cerrar sesión
                </button>
                <button type="button" class="btn btn-block btn-success btn-lg mr-3" data-toggle="modal" data-target="#modalAddNote">
                    Añadir nota
                </button>
            </div>
            <div class="row py-3">
                <div class="col">
                    <h1>Listado de notas</h1>
                </div>
            </div>
            <div class="row py-3">
                <ul>
                    <li class="text-danger">No hay notas!!!</li>
                </ul>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modalAddNote" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Añadir nota</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
                <form>
                    <div class="form-group">
                        <label for="description">Descripción</label>
                        <textarea class="form-control" id="description"></textarea>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-primary" id="addNote">Guardar</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
            </div>
          </div>
        </div>
      </div>

    <script 
        src="https://code.jquery.com/jquery-3.5.1.min.js" 
        integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" 
        crossorigin="anonymous">
    </script>
    <script 
        src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js" 
        integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns" 
        crossorigin="anonymous">
    </script>
</body>
<script>
    var urls = {
        login: "http://localhost:8000/login",
        notas: "http://localhost:8000/notes"
    }
    var token;
</script>
<script>
    $(() => {
        function getNotes() {
            $.ajax({
                type: "GET",
                url: urls.notas,
                dataType: "json",
                headers: { 'x-access-token': token },
                success: function (data) {
                    $('ul').html('');
                    for (let index = 0; index < data.length; index++) {
                        const element = data[index];
                        $('ul').append('<li>' + element.description + '</li>');
                    }
                },
                error: function (xhr, desc, err) {
                    console.error(xhr, desc, err)
                }
            });
        }
        $("#login").on('click', function (params) {
            $.ajax({
                type: "POST",
                url: urls.login,
                data: JSON.stringify(
                    { 
                        username: $('#username').val(),
                        password: $('#password').val(),
                    }
                ),
                dataType: 'json',
                contentType: 'application/json;charset=UTF-8',
                success: function (data) {
                    token = data.token;
                    $('#error-login').hide();
                    $('#mostrar-api').show();
                    $('#mostrar-login').hide();
                    getNotes();
                },
                error: function (xhr, desc, err) {
                    $('#error-login').show();
                    $('#mostrar-api').hide();
                    $('#mostrar-login').show();
                }
            });
        });
        $("#cerrar-sesion").on('click', function (params) {
            token = null;
            $('#mostrar-api').hide();
            $('#mostrar-login').show();
        });
        $("#addNote").on('click', function (params) {
            $.ajax({
                type: "POST",
                url: urls.notas,
                headers: { 'x-access-token': token },
                data: JSON.stringify(
                    { 
                        description: $('#description').val()
                    }
                ),
                dataType: 'json',
                contentType: 'application/json;charset=UTF-8',
                success: function (data) {
                    $("#modalAddNote").modal('toggle')
                    getNotes();
                },
                error: function (xhr, desc, err) {
                    console.error(xhr, desc, err)
                }
            });
        });
    });
</script>
</html>